/*
 *  exo09.c
 *  triage à boulles d'un tableau
 */

#include <stdio.h>
#include "exo07.h"

// ceci est une macro: la substitution des macro est faite pendant
// la compilation, donc ne prende aucune operation pendant l'execution
#define MAX 1000

void bubble_sort(int a[], unsigned int taille) {
  unsigned short int continuer;  // booléenne pour marquer si le
                                 // tableau est déjà trié
  int i;
  do {
    continuer = 0;
    for (i = 0; i < taille-1; i++) {
      cont++;
      if(a[i] > a[i+1]) {
        continuer = 1;
        swap(&a[i],&a[i+1]);
      }
    }
    taille--; // à la sortie du for il est sur que l'element
              // plus elevé des nombres comparés est à son place
              // donc on peut eviter de contrôler après
  } while(continuer); // comme ça la fonction sorte si le tableau
                      // deviènne trié avant que taille == 0;
}

int main() {
  int n;
  int a[MAX];
  printf("Bonjour !\n");
  printf("Svp, tapez le nombre des données : ");
  scanf("%d",&n);
  int i;
  for (i = 0; i < n; i++) {
    printf("Svp, tapez le %de entier : ",i+1);
    scanf("%d",&a[i]);
  }
  bubble_sort(a,n);
  printf("Resultat:");
  for(i = 0; i < n; i++) {
    printf(" %d",a[i]);
  }
  printf("\nAu revoir !\n",cont);
}
